-- Runs a simple mouse example running in tandem with a module that increments
-- a counter and displays it. When the two scripts are finished, it creates a
-- multithread TIL file called RAT.TPZ which you can load with RUNTIL.EX
include topaz2.e
include mkti2.e
sequence code,cod
integer id,id2
cod={
     {tPOSITION,1,1},
     {tPUSHA,1},
     {tPUSHD,1},
     {tADD},
     {tPOP,1},
     {tPUSHA,1},
     {tDISP},
     {tJMP,1}
    }
code={
      {tMODE,18},
      {tPOP,0},
      {tPUTST,"\nCheck out this simple mouse example,\nenabled by Jiri Babor's rat.e:"},
      {tPUTST,"\nClick the left mouse button to exit"},
      {tINIT},
      {tMOUSEPTR,1},
      {tRAT},
      {tMOUSEBTNS},
      {tPUSHD,1},
      {tNEQ},
      {tIF,{tJMP,7}},
      {tFINDNAME,"Counter module"},
      {tKILL},
      {tMODE,12},
      {tEND}
     }
id=new_thread(1,0,code)
id2=new_thread(1,0,cod)
setThreadName(id,"Rat example")
setThreadName(id2,"Counter module")
while get_num_threads() do
    topaz_step()
end while
makeTIL({code,cod},{0,1},{0,0},"rat.tpz",{"An example of using the mouse functions","Mouse module","Counter module"},{0,1},0)

