-- TIL loader v1.0
-- To load more than one TIL at a time, separate the names with commas(wether
-- on the command line or prompted)
include topaz2.e
function split(sequence s,integer ch)
    sequence s2 s2={""}
    for a = 1 to length(s) do
	if s[a]=ch then
	    s2 &= {""}
	else
	    s2[length(s2)] &= s[a]
	end if
    end for
    return s2
end function
sequence fil,cmd,comments
object stuff,id
puts(1,"Topaz Instruction List(TIL) file executer\n")
cmd=command_line()
if length(cmd)=2 then
    fil=prompt_string("file name to execute? ")
else
    fil=cmd[3]
end if
if equal(fil,"") then
    abort(0)
end if
fil=split(fil,',')
for a = 1 to length(fil) do
    if not find('.',fil[a]) then
	fil[a] &= ".tpz"
    end if
end for
for a = 1 to length(fil) do
    stuff=readTIL(fil[a])
    if equal(stuff,-1) then
	puts(1,"Can't find '"&fil[a]&"'\n")
    elsif equal(stuff,-2) then
	puts(1,'\''&fil[a]&"' isn't a valid TIL script\n")
	abort(2)
    end if
    id=stuff[1]
    comments=stuff[2]
    if equal(comments,"") or equal(comments," ") then
	comments="(None)"
    end if
    puts(1,"Comments: "&comments&'\n')
end for
if length(cmd)=2 then
    cmd_line={}
else
    cmd_line=cmd[3..length(cmd)]
end if
while get_num_threads()>0 do
    topaz_step()
end while
