-- Example of messages in Topaz
-- (Note the simple loop used. This is due to thread priorities. I could give
-- the error-checking thread top-priority, but this would make every other
-- thread crawl like a worm[at least on my Pentium-133]. Rather than slowing
-- down every thread, I wasted a little time so the error-checking thread
-- could process the message)

-- If error checking is active, it will deliberately trigger an error
include topaz2.e
sequence code
integer id
code={
      {tPOST,1,1},      -- Post error-checking message
      {tGET,2},         -- Get confirmation message
      {tPUSHD,1},
      {tEQ},
      {tIF,{tINCIP,3}},
      {tPUTST,"Error checking inactive\n"},
      {tINCIP,3},
      {tPUTST,"Error checking active\n"},
      {tPUTST}, -- There's nothing on the stack. This will attempt to push
		-- a value off of it so the error checking thread will kick in
      {tEND}
     }
id=new_thread(1,0,code)
while get_num_threads()>0 do
    topaz_step()
end while
