-- Topaz program file maker version 1, for unlimited string space
include machine.e
include get.e
function fmt(sequence s,integer waybig)
    object i
    integer j
    sequence out
    waybig=0
    if waybig=0 then
	return s
    end if
    out={}
    for k = 1 to length(s) do
	j=0
	i=s[k]
	if i < 0 then
	    -- Is negative. Make positive and indicate to restore
	    -- it to negative upon load
	    j=1
	    i=-i
	end if
	if atom(i) and not integer(i) then
	    -- Convert to 32-bit f.p. value
	    j+=2
	    i=atom_to_float32(i)
	elsif i > 255 and i <= #FFFF then
	    -- Too big for byte but too small for doubleword
	    -- Convert to word
	    j+=4
	    i=floor(i/#100)&and_bits(i,#FF)
	elsif i > #FFFF then
	    -- To small for word
	    -- Convert to doubleword
	    j+=8
	    i=int_to_bytes(i)
	end if
	out &= j&i
    end for
    return out
end function
global procedure makeTIL(sequence tCODE,object dSIZE,sequence tFLAGS,
			 sequence outFile,sequence comms,object priority,
			 integer bigFmt)
    sequence st,main,waybig
    integer fn,modules,j,k,iSize
    object i
    waybig=repeat(0,length(tCODE))
    if bigFmt then
	iSize=4
    else
	iSize=1
    end if
    modules=length(tCODE)
    fn=open(outFile,"wb")
    if fn=-1 then
	return
    end if
    if equal(comms,"") then
	comms=" "
    end if
    if atom(dSIZE) then
	dSIZE={dSIZE}
    end if
    if integer(comms[1]) then
	comms={comms}
    end if
    if length(comms) >= 2 then
	main=comms[1]
	comms=comms[2..length(comms)]
    else
	main=comms[1]
    end if
    puts(fn,"TOPAZ"&1&length(main)&main&length(comms))
    for a = 1 to length(comms) do
	puts(fn,length(comms[a])&comms[a])
    end for
    puts(fn,modules)
    for a = 1 to length(dSIZE) do
	puts(fn,int_to_bytes(dSIZE[a]))
    end for
    puts(fn,tFLAGS&priority&waybig&bigFmt)
    for a = 1 to length(tCODE) do
	puts(fn,int_to_bytes(length(tCODE[a])))
	for z = 1 to length(tCODE[a]) do
	    k=1
	    st={}
	    for x = 1 to length(tCODE[a][z]) do
		if sequence(tCODE[a][z][x]) then
		    st &= 255&0&fmt(tCODE[a][z][x],waybig[a])&{0,255,128,64}
		else
		    i=tCODE[a][z][x]
		    j=0
		    if waybig[a] and k > iSize then
			if i < 0 then
			    -- Is negative. Make positive and indicate to restore
			    -- it to negative upon load
			    j=1
			    i=-i
			elsif atom(i) and not integer(i) then
			    -- Convert to 32-bit f.p. value
			    j=2
			    i=atom_to_float32(i)
			elsif i > 255 and i <= #FFFF then
			    -- Too big for byte but too small for doubleword
			    -- Convert to word
			    j=3
			    i=floor(i/#100)&and_bits(i,#FF)
			elsif i > #FFFF then
			    -- To small for word
			    -- Convert to doubleword
			    j=4
			    i=int_to_bytes(i)
			end if
			st &= j&i
		    else
			st &= i
		    end if
		end if
		k += 1
	    end for
	    if bigFmt then
		puts(fn,length(st)-1&int_to_bytes(st[1])&st[2..length(st)])
	    else
		puts(fn,length(st)&st)
	    end if
	end for
    end for
    close(fn)
end procedure
