-- These are support functions for the standard EAD routine
procedure clear_lines(sequence lins)
    sequence vc,pos
    integer mode,cols,lines
    vc=video_config()
    mode=vc[VC_MODE]
    cols=vc[VC_COLUMNS]
    lines=vc[VC_LINES]
    pos=get_position()
    for z = 1 to length(lins) do
	if lins[z] < lines and lins[z] >= 1 then
	    position(lins[z],1)
	    puts(2,repeat(32,cols))
	end if
    end for
    position(pos[1],pos[2])
end procedure
procedure EADMsg()
    puts(1,"\n*** ETSE Error Detector v0.01 ***\n")
end procedure
function getKey(sequence lst,object ch)
    sequence pos
    integer i,k
    i=1
    pos=get_position()
    while 1 do
	position(pos[1],pos[2])
	for z = 1 to length(lst) do
	    if z=i then
		text_color(10)
	    else
		text_color(2)
	    end if
	    puts(2,lst[z])
	    if z < length(lst) then
		puts(2,ch)
	    end if
	end for
	k=wait_key()
	if k=13 then
	    exit
	elsif k=331 or k=328 then
	    if i-1 >= 1 then i -= 1 end if
	elsif k=333 or k=336 then
	    if i+1 <= length(lst) then i += 1 end if
	elsif k=327 then
	    i=1
	elsif k=335 then
	    i=length(lst)
	end if
    end while
    puts(2,'\n')
    return i
end function
procedure menu()
    sequence threads,threadIDs,scrn,pos,vc,fil,s
    integer i,maxThread,thred,mode,id,key,domenu
    object ret,TIL
    domenu=0
    vc=video_config() mode=vc[VC_MODE]
    if mode <= 3 or mode=7 then
	scrn=save_text_image({1,1},vc[3..4])
    else
	scrn=save_image({0,0},vc[VC_XPIXELS..VC_YPIXELS])
    end if
    pos=get_position()
    clear_screen()
    puts(2,"Select action:\n\n")
    i=getKey({"Thread status","Delete thread","Load VMS","Create VMS","Load script","Return"},10)
    if i=1 then
	threads={}
	maxThread=0
	for z = 1 to length(ThreadIDTable) do
	    threads &= ThreadIDTable[z]
	    if ThreadIDTable[z] > maxThread then
		maxThread=ThreadIDTable[z]
	    end if
	end for
	thred=-1
	threads=getThreadNames()
	threadIDs=threads[2]
	threads=threads[1]
	threads &= {"Never mind"}
	thred=getKey(threads,", ")
	if thred < length(threads) then
	    clear_screen()
	    id=getThreadID(thred)
	    printf(2,"\"%s's\" status:\n",{getThreadName(id)})
	    if isSuspended(id) then
		printf(2,"This thread is suspended by thread #%d(%s)\n",
			 {SuspendedBy[find(id,threadIDs)],getThreadName(SuspendedBy[find(id,threadIDs)])})
	    else
		puts(2,"This thread is currently running\n")
	    end if
	    printf(2,"This thread's data space size is %d elements\n",length(DataSpaceTable[thred]))
	    printf(2,"Current length of stack: %d elements\n",length(StackTable[thred]))
	    printf(2,"Current IP: %d\n",getIP(thred))
	    puts(2,"F1: See stack\nF2: See data space\nQ: Return to menu\nEsc: Return to program\n")
	    key=0
	    while 1 do
		if find(key,"Qq"&{315,316,27}) then puts(2,"Press any key...\n") end if
		key=wait_key()
		if key=315 then
		    printf(2,"\"%s's\" stack table:\n",{getThreadName(id)})
		    for a = 1 to length(StackTable[thred]) do
			print(2,StackTable[thred][a])
			if a < length(StackTable[thred]) then
			    puts(2,' ')
			end if
		    end for
		    puts(2,'\n')
		elsif key=316 then
		    printf(2,"\"%s's\" data space:\n",{getThreadName(id)})
		    for a = 1 to length(DataSpaceTable[thred]) do
			print(2,DataSpaceTable[thred][a])
			if a < length(DataSpaceTable[thred]) then
			    puts(2,' ')
			end if
		    end for
		    puts(2,'\n')

		elsif key='Q' or key='q' then
		    domenu=1
		    exit
		elsif key=27 then
		    exit
		end if
	    end while
	end if
    elsif i=2 then
	clear_screen()
	threads={}
	maxThread=0
	for z = 1 to length(ThreadIDTable) do
	    threads &= ThreadIDTable[z]
	    if ThreadIDTable[z] > maxThread then
		maxThread=ThreadIDTable[z]
	    end if
	end for
	thred=-1
	threads=getThreadNames()
	threadIDs=threads[2]
	threads=threads[1]
	threads=threads[1..length(threads)]&{"Never mind"}
	threadIDs=threadIDs[1..length(threadIDs)]
	thred=getKey(threads,", ")
	if thred < length(threads)+1 then
	    trace(1)
	    s={}
	    for a = 1 to length(SuspendedBy) do
		if SuspendedBy[a]=thred and not find(threadIDs[a],s) then
		    s &= ThreadIDTable[a]
		end if
	    end for
	    if length(s) then
		puts(2,"You can't delete this thread because it has suspended these threads:\n")
		for a = 1 to length(s) do
		    printf(2,"%s(thread %d)",{getThreadName(s[a]),s[a]})
		    if a < length(s) then
			puts(2,", ")
		    end if
		end for
		puts(2,"\nPress any key...")
		if wait_key() then end if
	    else
		if and_bits(ThreadFlags[thred],FLAGS_KILL2)=FLAGS_KILL2 then
		    puts(2,"This thread has level 2 kill protection and can't be deleted\n")
		    puts(2,"Press any key to continue...")
		    if wait_key() then end if
		elsif and_bits(ThreadFlags[thred],FLAGS_KILL1)=FLAGS_KILL1 then
		    puts(2,"This thread has level 1 kill protection.\n"&
			   "Are you sure you want to delete it(Y/N)? ")
		    key=-1
		    while not find(key,"YNyn") do
			key=wait_key()
		    end while
		    if find(key,"Yy") then
			kill_thread(threadIDs[thred])
		    end if
		else
		    kill_thread(threadIDs[thred])
		end if
	    end if
	    trace(1)
	    domenu=1
	end if
    elsif i=3 then
	puts(2,"\n ** ETSE VM loader **\n")
	fil=prompt_string("Enter filename to load(nothing to abort): ")
	if length(fil) then
	    if not find('.',fil) then
		fil &= ".vms"
	    end if
	    ret=loadState(fil)
	    vc=video_config()
	    mode=vc[VC_MODE]
	    if mode <= 3 or mode=7 then
		scrn=save_text_image({1,1},vc[3..4])
	    else
		scrn=save_image({0,0},vc[VC_XPIXELS..VC_YPIXELS])
	    end if
	    if ret=1 then
		puts(2,"\nCan't find \""&fil&"\"\nPress a key to continue\n")
		if wait_key() then
		end if
	    elsif ret=2 then
		puts(2,"\n\""&fil&"\" is not a Virtual Machine Status file\n"&
		       "Press a key to continue\n")
		if wait_key() then
		end if
	    end if
	end if
    elsif i=4 then
	puts(2,"\n ** ETSE VM saver **\n")
	fil=prompt_string("Enter filename to save to(nothing to abort): ")
	if mode <= 3 or mode=7 then
	    display_text_image({1,1},scrn)
	else
	    display_image({0,0},scrn)
	end if
	position(pos[1],pos[2])
	if length(fil) then
	    if not find('.',fil) then
		fil &= ".vms"
	    end if
	    saveState(fil)
	    domenu=1
	end if
    elsif i=5 then
	fil=prompt_string("Enter filename to load(nothing to abort): ")
	if length(fil) then
	    if not find('.',fil) then
		fil &= ".tpz"
	    end if
	    TIL=readTIL(fil)
	    if atom(TIL) then
		if TIL=-1 then
		    puts(2,"The file \""&fil&"\" does not exist\n")
		elsif TIL=-2 then
		    puts(2,"The file \""&fil&"\" is not a valid TIL script\n")
		end if
		puts(1,"Press any key to continue...\n")
		if wait_key() then
		end if
	    end if
	end if
    end if
    if mode <= 3 or mode=7 then
	display_text_image({1,1},scrn)
    else
	display_image({0,0},scrn)
    end if
    position(pos[1],pos[2])
    if domenu then
	menu()
    end if
end procedure
-- This is the standard EAD. To use one of your own design, create a new one
-- and set the integer checkThreadID to the routine_id of your EAD.
procedure checkThread(integer threadid,integer threadip)
    sequence Full,scrn,vc,pos
    integer instr,stackSize,mode
    threadid=find(threadid,ThreadIDTable)
    if threadid=0 then
	return
    end if
    Full=InstructionSpaceTable[threadid][threadip]
    instr=Full[1]
    stackSize=length(StackTable[threadid])
-- procedure @EAD1()
	    if instr=tPOP
	    and stackSize=0 then
		pos=get_position()
		vc=video_config()
		mode=vc[VC_MODE]
		if mode <= 3 or mode=7 then
		    scrn=save_text_image({1,1},vc[3..4])
		else
		    scrn=save_image({0,0},vc[5..6])
		end if
		EADMsg()
		puts(1,"Code: STACK01\n")
		printf(1,"Error detected in thread #%d(%s)\n",{threadID(threadid),
							    getThreadName(threadID(threadid))})
		puts(1,"Attempt to pop a value off an empty stack\n")
		showIP()
		terminate(threadid)
		if mode <= 3 or mode=7 then
		    display_text_image({1,1},scrn)
		else
		    display_image({0,0},scrn)
		end if
		position(pos[1],pos[2])
-- procedure @EAD2()
	    elsif instr=tPUSHD and length(Full) < 2 then
		pos=get_position()
		vc=video_config()
		mode=vc[VC_MODE]
		if mode <= 3 or mode=7 then
		    scrn=save_text_image({1,1},vc[3..4])
		else
		    scrn=save_image({0,0},vc[5..6])
		end if
		EADMsg()
		puts(1,"Code: STACK03\n")
		printf(1,"Error detected in thread #%d(%s)\n",{threadID(threadid),
							getThreadName(threadID(threadid))})
		puts(1,"Not enough values for tPUSHD\n")
		showIP()
		terminate(threadid)
		if mode <= 3 or mode=7 then
		    display_text_image({1,1},scrn)
		else
		    display_image({0,0},scrn)
		end if
		position(pos[1],pos[2])
-- procedure @EAD2()
	    elsif instr=tPUSHA and length(Full) < 2 then
		pos=get_position()
		vc=video_config()
		mode=vc[VC_MODE]
		if mode <= 3 or mode=7 then
		    scrn=save_text_image({1,1},vc[3..4])
		else
		    scrn=save_image({0,0},vc[5..6])
		end if
		EADMsg()
		puts(1,"Code: STACK04\n")
		printf(1,"Error detected in thread #%d(%s)\n",{threadID(threadid),
							getThreadName(threadID(threadid))})
		puts(1,"No virtual address for tPUSHA\n")
		showIP()
		terminate(threadid)
		--kill_thread(z-1)
		if mode <= 3 or mode=7 then
		    display_text_image({1,1},scrn)
		else
		    display_image({0,0},scrn)
		end if
		position(pos[1],pos[2])
-- procedure @EAD3()
	    elsif instr=tPUSHA and length(DataSpaceTable[threadid])<Full[2] and
		  executed[threadid]=0 then
		pos=get_position()
		vc=video_config()
		mode=vc[VC_MODE]
		if mode <= 3 or mode=7 then
		    scrn=save_text_image({1,1},vc[3..4])
		else
		    scrn=save_image({0,0},vc[5..6])
		end if
		EADMsg()
		puts(1,"Code: STACK02\n")
		printf(1,"Error detected in thread #%d(%s)\n",{threadID(threadid),
					    getThreadName(threadID(threadid))})
		printf(1,"Attempt to retreive data from out-of-range data space(%d is bigger than %d)\n",
			 {Full[2],length(DataSpaceTable[threadid])})
		showIP()
		terminate(threadid)
		--kill_thread(z-1)
		if mode <= 3 or mode=7 then
		    display_text_image({1,1},scrn)
		else
		    display_image({0,0},scrn)
		end if
		position(pos[1],pos[2])
-- procedure @EAD4()
	    elsif find(instr,{tPUTST,tPRINTF}) then
		 if (instr=tPUTST and stackSize and length(Full)=1)
		 or (instr=tPRINTF and stackSize<3) and executed[threadid]=0 then
		    pos=get_position()
		    vc=video_config()
		    mode=vc[VC_MODE]
		    if mode <= 3 or mode=7 then
			scrn=save_text_image({1,1},vc[3..4])
		    else
			scrn=save_image({0,0},vc[5..6])
		    end if
		    EADMsg()
		    if instr=tPUTST then
			puts(1,"Code: PUTS01\n")
		    else
			puts(1,"Code: PUTS02\n")
		    end if
		    printf(1,"Error detected in thread #%d(%s)\n",{threadID(threadid),
						    getThreadName(threadID(threadid))})
		    puts(1,"Attempt to pop a value off an empty stack\n")
		    showIP()
		    terminate(threadid)
		    --kill_thread(z-1)
		    if mode <= 3 or mode=7 then
			display_text_image({1,1},scrn)
		    else
			display_image({0,0},scrn)
		    end if
		    position(pos[1],pos[2])
		 end if
-- procedure @EAD5()
	    elsif instr=tSQRT and length(Full)=1 and stackSize=0 then
		pos=get_position()
		vc=video_config()
		mode=vc[VC_MODE]
		if mode <= 3 or mode=7 then
		    scrn=save_text_image({1,1},vc[3..4])
		else
		    scrn=save_image({0,0},vc[5..6])
		end if
		EADMsg()
		printf(1,"An error was detected in thread #%d(%s)\n",{threadID(threadid),
						      getThreadName(threadID(threadid))})
		puts(1,"Code: STACK01\nAttempt to pop a value off an empty "&
		       "stack\n")
		showIP()
		terminate(threadid)
		if mode <= 3 or mode=7 then
		    display_text_image({1,1},scrn)
		else
		    display_image({0,0},scrn)
		end if
		position(pos[1],pos[2])
	    end if
	    executed[threadid]=0
--    end if
    if getmsg(1) then -- Did a thread ask us if we exist?
	postmsg(2,1)  -- Yes, post confirmation message
	clearmsg(1)   -- Clear the message we just got
    end if
end procedure
checkThreadID=routine_id("checkThread")
procedure myOtherStuff()
    sequence pos,vc,scrn,threads
    integer k,mode
    k=peek(#417)
    if Input(96)=93 then
	menu()
    -- Scan code 104 is the "Stop" browser key on Microsoft's internet key-
    -- boards
    elsif Input(96)=104 or (Input(96)=83 and and_bits(k,4)=4 and (and_bits(k,1)=1 or and_bits(k,2)=2)) then
	pos=get_position()
	vc=video_config()
	mode=vc[VC_MODE]
	if mode <= 3 or mode=7 then
	    scrn=save_text_image({1,1},vc[3..4])
	else
	    scrn=save_image({0,0},vc[5..6])
	end if
	if graphics_mode(3) then end if
	puts(2,"This command will kill all running threads, any number of which\n"&
	       "could be handling *very* delicate processes. Are you sure you want\n"&
	       "to kill all threads(Y/N)? ")
	while not find(k,"YNyn") do
	    k=get_key()
	end while
	puts(1,k)
	if find(k,"Yy") then
	    puts(2,'\n')
	    threads=ThreadIDTable
	    for a = 1 to length(threads) do
		puts(2,"Deleting \""&getThreadName(threads[a])&"\"\n")
		kill_thread(threads[a])
	    end for
	    puts(2,"Done. Your Topaz session should end right about now.\n")
	    return
	end if
	if graphics_mode(mode) then end if
	if mode <= 3 or mode=7 then
	    display_text_image({1,1},scrn)
	else
	    display_image({0,0},scrn)
	end if
	position(pos[1],pos[2])
    end if
end procedure
stuffID=routine_id("myOtherStuff")
